package com.maroontress.sanctuary;

import org.w3c.dom.Element;
import org.w3c.dom.NodeList;
import java.io.PrintWriter;

/**
   ¤ΤΥФޤ϶ΤΥФΤstructޤunionޤ
   enumΥФǤ

   Υ饹ɽФϥѥɥФȸƤӤޤΥФ
   ƤϹ¤Τޤ϶ΤǤ

   structmemberǡunionmemberǡenummemberǤбޤ
*/
public abstract class CompoundMember extends Member implements Compound {

    /** ι¤Τޤ϶Τޤ󷿤ΰѾ */
    private CompoundImpl impl;

    /** ι¤Τޤ϶Τޤ󷿤̾ */
    private Strings name;

    /**
       ѥɥФޤ

       @param g 饹
       @param parentName Ƥ̾
       @param label "struct" ޤ "union" ޤ "enum"
       @param tag ̾
       @param elem structmemberǤޤunionmemberǤޤ
       enummember
    */
    protected CompoundMember(final Group g, final Strings parentName,
			     final String label, final Strings tag,
			     final Element elem) {
	super(g, parentName,
	      ((tag.getQualified().equals(""))
	       ? label : label + " " + tag.getQualified()),
	      elem);
	impl = null;

	if (tag.getQualified().equals("")) {
	    String s = "@" + IDManager.getInstance().getUniqueID();
	    name = Strings.intern(label + " " + s);
	} else {
	    name = Strings.prepend(label + " ", tag);
	}
	setDescType(name.getQualified());
    }

    /**
       ѥɥФ̾ޤ

       @return ѥɥФ̾
    */
    public Strings getCompoundName() {
	return name;
    }

    /**
       ѥɤμꤷޤ

       @param impl ѥɤμ
    */
    protected void setCompoundImpl(final CompoundImpl impl) {
	this.impl = impl;
    }

    /**
       ѥɤޤ

       @param c ȤʤǤλҥΡɥե륿
       @return ѥɤ
    */
    protected static Description getDescription(final ChildrenFilter c) {
	NodeList tagNodes = c.getDirectChildrenByTagName("tag");
	if (tagNodes.getLength() == 0) {
	    return new Description();
	}
	ChildrenFilter gc = new ChildrenFilter((Element) tagNodes.item(0));
	NodeList descNodes = gc.getDirectChildrenByTagName("desc");
	return new Description(descNodes);
    }

    /**
       {@inheritDoc}
    */
    @Override public void printCode(final PrintWriter wr,
				    final String indent) {
	wr.println(indent + getType() + " {");
	String nextIndex = indent + "    ";
	impl.getComponents().printCode(wr, nextIndex);
	wr.println(indent + "} " + getName() + ";");
    }

    public void printCompoundSummary(final PrintWriter wr) {
	impl.printCompoundSummary(wr);
    }

    public void printCompoundDetail(final PrintWriter wr) {
	impl.printCompoundDetail(wr);
    }

    public void printTexCompoundDetail(final PrintWriter wr) {
	impl.printTexCompoundDetail(wr);
    }

}
